<template>
  <div>
    <el-form :model="companyApply" :rules="rules" label-width="80px">
      <el-form-item label="公司名称" prop="name">
        <el-input
          v-model="companyApply.name"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="统一信用代码" prop="creditCode">
        <el-input
          v-model="companyApply.creditCode"
          placeholder="请输入统一信用代码"
        />
      </el-form-item>
      <el-form-item label="通讯地址" prop="address">
        <el-input
          v-model="companyApply.address"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="网址" prop="webSite">
        <el-input v-model="companyApply.webSite" placeholder="请输入网址" />
      </el-form-item>
      <el-form-item label="公司简介" prop="companyDesc">
        <el-input
          v-model="companyApply.companyDesc"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="联系人姓名" prop="contactName">
        <el-input
          v-model="companyApply.contactName"
          placeholder="请输入联系人姓名"
        />
      </el-form-item>
      <el-form-item label="联系人职位" prop="contactPosition">
        <el-input
          v-model="companyApply.contactPosition"
          placeholder="请输入联系人职位"
        />
      </el-form-item>
    </el-form>
    <el-form :model="testerApply" label-width="80px">
      <el-form-item label="测试项目经历" prop="testProjects">
        <el-input
          v-model="testerApply.testProjects"
          type="textarea"
          placeholder="请输入内容"
        /><el-link type="primary">查看示例</el-link>
      </el-form-item>
      <!-- <el-form-item label="上传其它补充材料"  prop="filePath">
          <multi-upload v-if="allFileGetFlag" v-model="testerApply.otherTQList" :serverAddr="materialServerAddr" fileName="其它补充材料" :limit="10" @setImgPath="setOtherPath"/>
        </el-form-item> -->
      <el-form-item label="补充说明" prop="otherInfo">
        <el-input
          v-model="testerApply.otherInfo"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="cancel">取 消</el-button>
    </div>
  </div>
</template>

<script>
import {
  listTesterApply,
  delTesterApply,
  addTesterApply,
  updateTesterApply,
  exportTesterApply,
  certificationStatus,
} from "@/api/tester/TesterApply";
import { addCompanyApply, updateCompanyApply } from "@/api/tester/CompanyApply";
import MultiUpload from "@/views/components/MultiUpload";

export default {
  name: "TesterApply",
  components: {
    MultiUpload,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 测试者认证申请表格数据
      TesterApplyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 申请类型0:普通用户申请为个人测试者；1:普通用户申请为企业测试者；2:企业申请为企业测试者字典
      applyTypeOptions: [],
      // 状态：0:unaudit;1:pass;2:unpass;字典
      statusOptions: [],
      // 审核时间时间范围
      daterangeAuditTime: [],
      // 创建时间时间范围
      daterangeCreateTime: [],
      // 更新时间时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        applyType: null,
        companyApplyId: null,
        name: null,
        city: null,
        idNumber: null,
        testSkills: null,
        testProjects: null,
        workExperience: null,
        certificate: null,
        otherInfo: null,
        status: null,
        auditorId: null,
        auditOpinion: null,
        auditTime: null,
      },
      // 表单参数
      userInfo: {},
      testerApply: {},
      companyApply: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "公司名称不能为空", trigger: "blur" },
        ],
        creditCode: [
          { required: true, message: "统一信用代码不能为空", trigger: "blur" },
        ],
        address: [
          { required: true, message: "通讯地址不能为空", trigger: "blur" },
        ],
        webSite: [{ required: true, message: "网址不能为空", trigger: "blur" }],
        companyDesc: [
          { required: true, message: "公司简介不能为空", trigger: "blur" },
        ],
        contactName: [
          { required: true, message: "联系人姓名不能为空", trigger: "blur" },
        ],
        contactPosition: [
          { required: true, message: "联系人职位不能为空", trigger: "blur" },
        ],
      },
      materialServerAddr: "",
      allFileGetFlag: false,
    };
  },
  created() {
    this.getApplyByUserID(this.$route.query.userId);
  },
  methods: {
    /** 查询测试者认证申请列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeAuditTime && "" != this.daterangeAuditTime) {
        this.queryParams.params["beginAuditTime"] = this.daterangeAuditTime[0];
        this.queryParams.params["endAuditTime"] = this.daterangeAuditTime[1];
      }
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listTesterApply(this.queryParams).then((response) => {
        this.TesterApplyList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 申请类型0:普通用户申请为个人测试者；1:普通用户申请为企业测试者；2:企业申请为企业测试者字典翻译
    applyTypeFormat(row, column) {
      return this.selectDictLabel(this.applyTypeOptions, row.applyType);
    },
    // 状态：0:unaudit;1:pass;2:unpass;字典翻译
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.status);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        applyId: null,
        userId: null,
        applyType: null,
        companyApplyId: null,
        name: null,
        city: null,
        idNumber: null,
        testSkills: null,
        testProjects: null,
        workExperience: null,
        certificate: null,
        otherInfo: null,
        status: null,
        auditorId: null,
        auditOpinion: null,
        auditTime: null,
        createTime: null,
        updateTime: null,
        idCardFrontUrl: [],
        idCardBackUrl: [],
        otherTQList: [],
        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeAuditTime = [];
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.applyId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加测试者认证申请";
    },
    /** 加载审核页面数据操作 */
    getApplyByUserID(userId) {
      certificationStatus().then((response) => {
        if (response.testerApply) {
          this.testerApply = response.testerApply;
        } else {
          this.testerApply = {};
        }
        if (response.companyApply) {
          this.companyApply = response.companyApply;
        } else {
          this.companyApply = {};
        }
        if (response.data) {
          this.userInfo = response.data;

          // getAllFileInfo(response.data.applyId).then((response) => {
          //   if (response.data) {
          //     if (response.data.idCardFrontUrl) {
          //       this.form.idCardFrontUrl = response.data.idCardFrontUrl;
          //     }
          //     if (response.data.idCardBackUrl) {
          //       this.form.idCardBackUrl = response.data.idCardBackUrl;
          //     }
          //     if (response.data.otherTQList) {
          //       this.form.otherTQList = response.data.otherTQList;
          //     }
          //   }
          //   this.materialServerAddr = response.msAddr;
          //   this.allFileGetFlag = true;
          // });
        } else {
          this.materialServerAddr = response.msAddr;
          this.allFileGetFlag = true;
        }
        this.open = true;
        this.title = "修改测试者认证申请";
      });
    },
    /** 提交按钮 */
    submitForm() {
      if (this.testerApply.applyId != null) {
        updateCompanyApply(this.companyApply).then((response) => {
          updateTesterApply(this.testerApply).then((response) => {
            this.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
        });
      } else {
        this.testerApply.applyType = 1;
        addCompanyApply(this.companyApply).then((response) => {
          addTesterApply(this.testerApply).then((response) => {
            this.msgSuccess("新增成功");
            this.open = false;
            this.getList();
          });
        });
      }
      // this.$refs["form"].validate(valid => {
      //   if (valid) {
      //     this.form.applyType = 2;
      //     if (this.form.applyId != null) {
      //       updateTesterApply(this.form).then(response => {
      //         this.msgSuccess("修改成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     } else {
      //       addTesterApply(this.form).then(response => {
      //         this.msgSuccess("新增成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     }
      //   }
      // });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const applyIds = row.applyId || this.ids;
      this.$confirm(
        '是否确认删除测试者认证申请编号为"' + applyIds + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delTesterApply(applyIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        });
    },
    setUpPath(value) {
      // this.form.idCardFrontUrl = value;
    },
    setDownPath(value) {
      // this.form.idCardBackUrl = value;
    },
    setOtherPath(value) {
      // if(this.form.otherTQList == undefined){
      //   this.form.otherTQList = [];
      // }
      // // console.log(this.form.otherTQList);
      // this.form.otherTQList.push(value);
      // // console.log(this.form.otherTQList);
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有测试者认证申请数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportTesterApply(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
  },
};
</script>
